'         SCCM  Remote Control   
' Copyright (C)  ..,  
' -, 2017
' .            SCCM
'         !
'   Windows XP/2003  

Option Explicit
On Error Resume Next
Const wbemFlagBidirectional     = &h00
Const wbemFlagForwardOnly       = &h20
Const wbemFlagReturnImmediately = &h10
' -------------------------------------------------------------------------------------------------
'     / .   
Const NUMBER_OF_COLLECTIONS = 4
'     True       
Const DEBUGLOG = True
'   .       SCCM   AD
Dim Mappings()
ReDim Mappings (NUMBER_OF_COLLECTIONS-1,1)
Mappings (0,0) = "1C"     		    : Mappings (0,1) = "DOMAIN/SCCM-RC_Access_1C"
Mappings (1,0) = "Directum_5_3" 	    : Mappings (1,1) = "DOMAIN/SCCM-RC_Access_Directum"
Mappings (2,0) = "PC_Remote_control_CRM"    : Mappings (2,1) = "DOMAIN/SCCM-RC_Access_CRM"
Mappings (3,0) = "PC_Remote_control_Invest" : Mappings (3,1) = "DOMAIN/SCCM-RC_Access_Invest"

' -------------------------------------------------------------------------------------------------
'   .   DEBUGLOG=True
Dim objFS, objLog, Collection_vars
If DEBUGLOG Then
	Set objFS = CreateObject("Scripting.FileSystemObject" ) ' 
	If (objFS.FileExists("C:\SCCM_RC_Config.log")) Then                          
		Set objLog= objFS.OpenTextFile  ("C:\SCCM_RC_Config.log",8   ) 
	Else
		Set objLog= objFS.CreateTextFile("C:\SCCM_RC_Config.log",True)        
		Log "   RC"
	End If
	Log " "
	Log CStr(Date()) & " " & CStr(Time())
	Log " ..."
End If

'   
Dim objShell,colSystemEnvVars, HostName
Set objShell = WScript.CreateObject("WScript.Shell") ' WSH
Set colSystemEnvVars = objShell.Environment("Process")
HostName=colSystemEnvVars("COMPUTERNAME")
Log " " & HostName & ".    WMI..."

Dim strQuery,objWMIService
strQuery = "SELECT * FROM CCM_CollectionVariable"
Set objWMIService = GetObject("winmgmts:\\" & "." & "\ROOT\ccm\Policy\Machine\ActualConfig")
'      WMI
If Err Then
	Log "    WMI,  "  & Err
	Err.Clear
	wScript.Quit 1
End If
Log "  WMI"
Set Collection_vars = objWMIService.ExecQuery(strQuery, "WQL", wbemFlagReturnImmediately + wbemFlagBidirectional)
If Err Then
	Log "  WMI-,  " & Err
	Err.Clear
	wScript.Quit 1
End If
Log " " & Collection_vars.Count & "  "

Log "  .     , !"
Dim TargetGroup,objLocalRC,objUser,objDomainGroup
TargetGroup = "   Configuration Manager"
Set objLocalRC = GetObject("WinNT://" & "./" & TargetGroup & ",group")
If Err Then
	Log "    ,  " & Err
	Err.Clear
	wScript.Quit 1
End If
For Each objUser In objLocalRC.Members
	objLocalRC.Remove(objUser.AdsPath)
	Next

Log "  "
Dim I,L,Flag
L=NUMBER_OF_COLLECTIONS-1
Flag=False
For I=0 To L
	If (FindCol(Mappings(I,0))) Then
		Flag = True
		Exit For
		End If
	Next
If Not Flag Then
	Log "   ,  "
	wScript.Quit 0
End If

Log " "
For I=0 To L
	If (FindCol(Mappings(I,0))) Then
		'   
		Log "   " & Mappings(I,0) & " <-> " & Mappings(I,1)
		Set objDomainGroup = GetObject("WinNT://" & Mappings(I,1) & ",group")
		objLocalRC.Add(objDomainGroup.ADsPath)
		End If
	Next

' 
Log " ."
wScript.Quit 0

' 
' -------------------------------------------------------------------------------------------------
' 
Sub Log(Str)
	If DEBUGLOG Then
	        objLog.WriteLine Str
	End If
End Sub

Function FindCol(strName)
	Dim objItem, Pref_Len
	Pref_Len=Len("Collection_RC_")
	FindCol = False
	For Each objItem in Collection_vars
		If (InStr(objItem.Name,"Collection_RC_")=1) Then
			If (StrComp(Right(objItem.Name, Len(objItem.Name)-Pref_Len),strName,vbTextCompare)=0) Then
				FindCol = True
				Exit For
			End If
		End If
	Next
End Function